WndProc 	proto :DWORD,:DWORD,:DWORD,:DWORD
LVProc 		proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

; to avoid problems with ucmacros.asm
fn MACRO FuncName:REQ,args:VARARG
  arg?? equ <invoke FuncName> 
  FOR var,<args>
    arg?? CATSTR arg??,<,reparg(var)>
  ENDM
  arg??
ENDM
rv MACRO FuncName:REQ,args:VARARG
  arg?? equ <invoke FuncName>
  FOR var,<args> 
    arg?? CATSTR arg??,<,reparg(var)>
  ENDM
  arg??
  EXITM <eax>
ENDM

; some list view macros
lv_add_column macro hwnd,icol,_cX,txt
	mov lvc_tmp.imask,LVCF_TEXT or LVCF_WIDTH
	mov lvc_tmp.pszText,chr$(txt)
	m2m lvc_tmp.lx,_cX
	invoke SendMessage,hwnd,LVM_INSERTCOLUMN,icol,OFFSET lvc_tmp
endm
lv_add_item macro hwnd,_iItem,txt
	mov lvi_tmp.imask,LVIF_TEXT
	m2m lvi_tmp.iItem,_iItem
	mov lvi_tmp.iSubItem,0
	mov lvi_tmp.pszText,chr$(txt)
	invoke SendMessage,hwnd,LVM_INSERTITEM,0,OFFSET lvi_tmp
endm

lv_set_item macro hwnd,_iItem,iSub,sz
	mov lvi_tmp.imask,LVIF_TEXT
	m2m lvi_tmp.iItem,_iItem
	m2m lvi_tmp.iSubItem,iSub
	mov lvi_tmp.pszText,chr$(sz)
	invoke SendMessage,hwnd,LVM_SETITEM,0,OFFSET lvi_tmp
endm

lv_set_line macro hWnd,iItem,szs:VARARG
	cntr? = 0
	FOR sz,<&szs>
		IF cntr? EQ 0
			lv_add_item hWnd,iItem,sz
		ELSE
			lv_set_item hWnd,iItem,%cntr?,sz
		ENDIF
		cntr? = cntr? + 1		
	ENDM
endm

; unicode version !
lv_get_item_W macro hwnd,_iItem,iSub,pwsz,ccwsz
	mov lvi_tmp.imask,LVIF_TEXT
	m2m lvi_tmp.iItem,_iItem
	m2m lvi_tmp.iSubItem,iSub
	m2m lvi_tmp.pszText,pwsz
	m2m lvi_tmp.cchTextMax,ccwsz
	invoke SendMessageW,hwnd,LVM_GETITEMW,0,OFFSET lvi_tmp
endm

; bug fix for windows.inc
_NMTTDISPINFOW STRUCT
  hdr               NMHDR  		<>
  lpszText          PWCHAR  	?
  _szText           WCHAR		80 dup(?)
  hinst             HINSTANCE	?
  uFlags            UINT		?
  lParam            LPARAM		?
_NMTTDISPINFOW ENDS



