include masm32rt.inc
include ListViewToolTip.Inc
include \masm32\macros\ucmacros.asm
.686p
.data?
	hInstance		dd ?
	g_hList			dd ?
	g_pOrgLVProc	dd ?
	g_hTT			dd ?
	g_nClmns		dd ?
	wcex			WNDCLASSEX <>
	msg				MSG <>
	lvc_tmp			LV_COLUMN 	<>
	lvi_tmp			LV_ITEM 	<>
.code
start:
	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,NULL
	mov wcex.hbrBackground,rv(CreateSolidBrush,0ffffffh)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("class32")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, OFFSET wcex
	
	mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
	mov esi,rv(GetSystemMetrics,SM_CYSCREEN)
	mov eax,edi
	mov edx,esi
	shr eax,2
	shr edx,2
	shr edi,1
	shr esi,1
		
	mov edi,rv(CreateWindowEx,0,wcex.lpszClassName,"ToolTip test",WS_OVERLAPPEDWINDOW,eax,edx,edi,esi,0,0,hInstance,0)
	invoke ShowWindow,eax,SW_SHOWNORMAL
	invoke UpdateWindow,edi

	.while 1
		.break .if !rv(GetMessage,OFFSET msg,0,0,0)
		invoke TranslateMessage, OFFSET msg
		invoke DispatchMessage, OFFSET msg
	.endw
	invoke ExitProcess,msg.wParam


WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL rect:RECT
LOCAL ti:TOOLINFO
	.if uMsg == WM_DESTROY
		invoke PostQuitMessage,0
	.elseif uMsg == WM_CREATE
		invoke GetClientRect,hWnd,ADDR rect
		mov g_hList,rv(CreateWindowEx,0,"SysListView32",0,WS_CHILD or WS_VISIBLE or LVS_REPORT,0,0,rect.right,rect.bottom,hWnd,0,hInstance,0)
		mov g_pOrgLVProc,rv(SetWindowLong,eax,GWL_WNDPROC,OFFSET LVProc)
		invoke SendMessage,g_hList, LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT,LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT
		
		mov g_nClmns,3	; 3 columns
		lv_add_column g_hList,0,100,"clmn0"
		lv_add_column g_hList,1,100,"clmn1"
		lv_add_column g_hList,2,100,"clmn2"
		lv_set_line g_hList,0,"A1","B1","C1"
		lv_set_line g_hList,1,"A2","B2","C2"
		lv_set_line g_hList,2,"A3","B3","C3"
				
		mov g_hTT,rv(CreateWindowExA,NULL,"tooltips_class32",NULL,WS_POPUP or TTS_NOPREFIX or TTS_ALWAYSTIP or TTS_BALLOON,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,hWnd, NULL, hInstance,NULL)
		
		mov ti.cbSize,SIZEOF TOOLINFO
		mov ti.uFlags,TTF_SUBCLASS
		m2m ti.hWnd,g_hList
		m2m ti.uId,g_hList
		invoke MemCopy,ADDR rect,ADDR ti.rect,SIZEOF RECT
		m2m ti.hInst,hInstance
		mov ti.lpszText,LPSTR_TEXTCALLBACK
		mov ti.lParam,0
		invoke SendMessage,g_hTT,TTM_ADDTOOL,0,ADDR ti
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

LVProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL lvht:LVHITTESTINFO
LOCAL ti:TOOLINFO
LOCAL pt:POINT
LOCAL wsz[128]:WCHAR

	.if uMsg == WM_MOUSEMOVE
		mov edx,ASM(mov eax,lParam)
		mov lvht.pt.x,ASM(movzx eax,ax)
		mov lvht.pt.y,ASM(shr edx,16)
		invoke SendMessage,hWnd,LVM_SUBITEMHITTEST,0,ADDR lvht
		.if eax != -1 && lvht.flags&LVHT_ONITEMLABEL
			invoke SendMessage,g_hTT,TTM_ACTIVATE,1,0
			mov ti.rect.left,LVIR_BOUNDS
			m2m ti.rect.top,lvht.iSubItem
			invoke SendMessage,hWnd,LVM_GETSUBITEMRECT,lvht.iItem,ADDR ti.rect
			
			mov ti.cbSize,SIZEOF TOOLINFO
			mov ti.uFlags,TTF_IDISHWND
			m2m ti.hWnd,hWnd
			m2m ti.uId,hWnd
			mov ti.hInst,0
			mov ti.lpszText,0
			mov ti.lParam,0
			lea eax,ti.rect
			invoke SendMessage,g_hTT,TTM_NEWTOOLRECT,0,ADDR ti
		.else
			invoke SendMessage,g_hTT,TTM_ACTIVATE,0,0
		.endif
	.elseif uMsg == WM_NOTIFY
		mov eax,lParam
		mov edx,g_hTT
		.if [eax].NMHDR.hwndFrom == edx
		 	.if [eax].NMHDR.code == TTN_GETDISPINFOW
		 		invoke GetCursorPos,ADDR pt
		 		invoke ScreenToClient,hWnd,ADDR pt
				m2m lvht.pt.x,pt.x
				m2m lvht.pt.y,pt.y
				invoke SendMessage,hWnd,LVM_SUBITEMHITTEST,0,ADDR lvht
				.if eax != -1 && lvht.flags&LVHT_ONITEMLABEL
					mov eax,lParam
					lea edx,wsz
		 			lv_get_item_W hWnd,lvht.iItem,lvht.iSubItem,edx,LENGTHOF wsz
		 			mov eax,lParam
		 			lea edx,[eax]._NMTTDISPINFOW._szText
		 			ucopy$ ADDR wsz,edx
		 		.endif
		 	.endif
		.endif
	.endif
	invoke CallWindowProc,g_pOrgLVProc,hWnd,uMsg,wParam,lParam
	ret

LVProc endp
end start
